// License: GPLv3 or later
// Author: AdmSasha <dik@inbox.ru>

#ifndef CBUILD_H
#define CBUILD_H

#include <string>
#include <map>
#include <vector>
#include <boost/asio.hpp>

using namespace std;

struct sProcResult {
    int status;
    string text;
};


class cBuild{
    public:
	cBuild(); 
	int build(map<string,string> _options);
	
    private:
	int checkOptions();
	int createUser();
	int copyAddons();
	int addDistrib();
	int addDistribOwn();
	int addMedia();
	int copySrpm();
	void clearBuild();
	void signalExit();
	sProcResult unPackArchive();
	sProcResult runproc(string cmd,bool isChroot,string user,int timeout);
	int copyBuiltPackages();

	boost::asio::io_service service;
	
        map<string,string> options;
        
        vector<string> list_mount_dev;
        
        bool isDeleteTmp;
        pid_t procBuildPid;
        bool normalExit;
        bool stopped;
        
	
};

#endif
